"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RealmTimingStatistics = exports.RealmStatistics = exports.ElementSize = undefined;

var _index = require("./values/index.js");

var _completions = require("./completions.js");

var _environment = require("./environment.js");

var _generator = require("./utils/generator.js");

/**
 * Copyright (c) 2017-present, Facebook, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 */

const ElementSize = exports.ElementSize = {
  Float32: 4,
  Float64: 8,
  Int8: 1,
  Int16: 2,
  Int32: 4,
  Uint8: 1,
  Uint16: 2,
  Uint32: 4,
  Uint8Clamped: 1
};

//

//

//

// TODO #26 #712: Promises. All kinds of iterators. Generators.

class RealmStatistics {
  constructor() {
    this.simplifications = 0;
    this.simplificationAttempts = 0;
    this.evaluatedNodes = 0;
  }


  log() {
    console.log(`=== realm statistics`);
    console.log(`${this.evaluatedNodes} AST nodes evaluated.`);
    console.log(`${this.simplifications} abstract values simplified after ${this.simplificationAttempts} attempts.`);
  }
}

exports.RealmStatistics = RealmStatistics;
class RealmTimingStatistics {
  constructor() {
    this.parsingTime = 0;
    this.fixupSourceLocationsTime = 0;
    this.fixupFilenamesTime = 0;
    this.evaluationTime = 0;
  }


  log(totalTime) {
    console.log(`=== timing statistics: ${totalTime}ms total time`);
    console.log(`${this.parsingTime}ms parsing, ${this.fixupSourceLocationsTime}ms fixing source locations, ${this.fixupSourceLocationsTime}ms fixing source locations, ${this.evaluationTime}ms evaluating global code`);
  }
}
exports.RealmTimingStatistics = RealmTimingStatistics;
//# sourceMappingURL=types.js.map